import os
import numpy as np
import pandas as pd
import face_recognition

# 사진 불러오기
n20191694_image = face_recognition.load_image_file("C:/Users/su000/Desktop/knowns/20191694.jpg")
n20194530_image = face_recognition.load_image_file("C:/Users/su000/Desktop/knowns/20194530.jpg")
n20174343_image = face_recognition.load_image_file("C:/Users/su000/Desktop/knowns/20174343.jpg")

# 사진 인코딩
n20191694_face_encoding = face_recognition.face_encodings(n20191694_image)[0]
n20194530_face_encoding = face_recognition.face_encodings(n20194530_image)[0]
n20174343_face_encoding = face_recognition.face_encodings(n20174343_image)[0]

# 알고있는 얼굴 인코딩값들을 저장할 list
known_face_encodings = [
    n20191694_face_encoding,
    n20194530_face_encoding,
    n20174343_face_encoding
]
known_face_names = [
    "20191694",
    "20194530",
    "20174343"
]
# make a list of all the available images
images = os.listdir('C:/Users/su000/Desktop/knowns')
print(images)

#for i in range(0, 3):
#    print("C:/Users/su000/eclipse-workspace/capstone/220615/{i}.jpg")

# load your image
for i in range(0, 3):
    
    
    image_to_be_matched = face_recognition.load_image_file(f"C:/Users/su000/eclipse-workspace/capstone/220616/{i}.jpg")
    
# encoded the loaded image into a feature vector
    face_locations = face_recognition.face_locations(image_to_be_matched, model = "HOG")
    image_to_be_matched_encoded = face_recognition.face_encodings(image_to_be_matched)[0]
# iterate over each image
    for face_encoding in image_to_be_matched_encoded:
      
    # load the image
    #current_image = face_recognition.load_image_file("C:/Users/su000/Desktop/knowns/" + image)
    # encode the loaded image into a feature vector
    #current_image_encoded = face_recognition.face_encodings(current_image)[0]
    # match your image with the image and check if it matches

    
        matches = face_recognition.compare_faces(known_face_encodings,image_to_be_matched_encoded, 0.4)
        face_distances = face_recognition.face_distance(known_face_encodings, image_to_be_matched_encoded)
        best_match_index = np.argmin(face_distances)
        print("best_match_index ; ", best_match_index)


        if matches[best_match_index]:
            name = known_face_names[best_match_index]
            print("%s 학생의 출석이 완료되었습니다." %name)
    
        else:
            print("출석 실패")
        break
